drop dead functions
[portage.git] / bin / ebuild.sh
1 #!/bin/bash
2 # Copyright 1999-2012 Gentoo Foundation
3 # Distributed under the terms of the GNU General Public License v2
4
5 PORTAGE_BIN_PATH="${PORTAGE_BIN_PATH:-/usr/lib/portage/bin}"
6 PORTAGE_PYM_PATH="${PORTAGE_PYM_PATH:-/usr/lib/portage/pym}"
7
8 # Prevent aliases from causing portage to act inappropriately.
9 # Make sure it's before everything so we don't mess aliases that follow.
10 unalias -a
11
12 source "${PORTAGE_BIN_PATH}/isolated-functions.sh" || exit 1
13
14 if [[ $EBUILD_PHASE != depend ]] ; then
15         source "${PORTAGE_BIN_PATH}/phase-functions.sh" || die
16         source "${PORTAGE_BIN_PATH}/save-ebuild-env.sh" || die
17         source "${PORTAGE_BIN_PATH}/phase-helpers.sh" || die
18         source "${PORTAGE_BIN_PATH}/bashrc-functions.sh" || die
19 else
20         # These dummy functions are for things that are likely to be called
21         # in global scope, even though they are completely useless during
22         # the "depend" phase.
23         for x in diropts docompress exeopts get_KV insopts \
24                 keepdir KV_major KV_micro KV_minor KV_to_int \
25                 libopts register_die_hook register_success_hook \
26                 strip_duplicate_slashes \
27                 use_with use_enable ; do
28                 eval "${x}() {
29                         if has \"\${EAPI:-0}\" 4-python; then
30                                 die \"\${FUNCNAME}() calls are not allowed in global scope\"
31                         fi
32                 }"
33         done
34         # These dummy functions return false in older EAPIs, in order to ensure that
35         # `use multislot` is false for the "depend" phase.
36         for x in use useq usev usex ; do
37                 eval "${x}() {
38                         if has \"\${EAPI:-0}\" 4-python; then
39                                 die \"\${FUNCNAME}() calls are not allowed in global scope\"
40                         else
41                                 return 1
42                         fi
43                 }"
44         done
45         # These functions die because calls to them during the "depend" phase
46         # are considered to be severe QA violations.
47         for x in best_version has_version portageq ; do
48                 eval "${x}() { die \"\${FUNCNAME}() calls are not allowed in global scope\"; }"
49         done
50         unset x
51 fi
52
53 # Don't use sandbox's BASH_ENV for new shells because it does
54 # 'source /etc/profile' which can interfere with the build
55 # environment by modifying our PATH.
56 unset BASH_ENV
57
58 # This is just a temporary workaround for portage-9999 users since
59 # earlier portage versions do not detect a version change in this case
60 # (9999 to 9999) and therefore they try execute an incompatible version of
61 # ebuild.sh during the upgrade.
62 export PORTAGE_BZIP2_COMMAND=${PORTAGE_BZIP2_COMMAND:-bzip2} 
63
64 # These two functions wrap sourcing and calling respectively.  At present they
65 # perform a qa check to make sure eclasses and ebuilds and profiles don't mess
66 # with shell opts (shopts).  Ebuilds/eclasses changing shopts should reset them 
67 # when they are done.
68
69 qa_source() {
70         local shopts=$(shopt) OLDIFS="$IFS"
71         local retval
72         source "$@"
73         retval=$?
74         set +e
75         [[ $shopts != $(shopt) ]] &&
76                 eqawarn "QA Notice: Global shell options changed and were not restored while sourcing '$*'"
77         [[ "$IFS" != "$OLDIFS" ]] &&
78                 eqawarn "QA Notice: Global IFS changed and was not restored while sourcing '$*'"
79         return $retval
80 }
81
82 qa_call() {
83         local shopts=$(shopt) OLDIFS="$IFS"
84         local retval
85         "$@"
86         retval=$?
87         set +e
88         [[ $shopts != $(shopt) ]] &&
89                 eqawarn "QA Notice: Global shell options changed and were not restored while calling '$*'"
90         [[ "$IFS" != "$OLDIFS" ]] &&
91                 eqawarn "QA Notice: Global IFS changed and was not restored while calling '$*'"
92         return $retval
93 }
94
95 EBUILD_SH_ARGS="$*"
96
97 shift $#
98
99 # Unset some variables that break things.
100 unset GZIP BZIP BZIP2 CDPATH GREP_OPTIONS GREP_COLOR GLOBIGNORE
101
102 [[ $PORTAGE_QUIET != "" ]] && export PORTAGE_QUIET
103
104 # sandbox support functions; defined prior to profile.bashrc srcing, since the profile might need to add a default exception (/usr/lib64/conftest fex)
105 _sb_append_var() {
106         local _v=$1 ; shift
107         local var="SANDBOX_${_v}"
108         [[ -z $1 || -n $2 ]] && die "Usage: add$(echo ${_v} | \
109                 LC_ALL=C tr [:upper:] [:lower:]) <colon-delimited list of paths>"
110         export ${var}="${!var:+${!var}:}$1"
111 }
112 # bash-4 version:
113 # local var="SANDBOX_${1^^}"
114 # addread() { _sb_append_var ${0#add} "$@" ; }
115 addread()    { _sb_append_var READ    "$@" ; }
116 addwrite()   { _sb_append_var WRITE   "$@" ; }
117 adddeny()    { _sb_append_var DENY    "$@" ; }
118 addpredict() { _sb_append_var PREDICT "$@" ; }
119
120 addwrite "${PORTAGE_TMPDIR}"
121 addread "/:${PORTAGE_TMPDIR}"
122 [[ -n ${PORTAGE_GPG_DIR} ]] && addpredict "${PORTAGE_GPG_DIR}"
123
124 # Avoid sandbox violations in temporary directories.
125 if [[ -w $T ]] ; then
126         export TEMP=$T
127         export TMP=$T
128         export TMPDIR=$T
129 elif [[ $SANDBOX_ON = 1 ]] ; then
130         for x in TEMP TMP TMPDIR ; do
131                 [[ -n ${!x} ]] && addwrite "${!x}"
132         done
133         unset x
134 fi
135
136 # the sandbox is disabled by default except when overridden in the relevant stages
137 export SANDBOX_ON=0
138
139 # Ensure that $PWD is sane whenever possible, to protect against
140 # exploitation of insecure search path for python -c in ebuilds.
141 # See bug #239560.
142 if ! has "$EBUILD_PHASE" clean cleanrm depend help ; then
143         cd "$PORTAGE_BUILDDIR" || \
144                 die "PORTAGE_BUILDDIR does not exist: '$PORTAGE_BUILDDIR'"
145 fi
146
147 #if no perms are specified, dirs/files will have decent defaults
148 #(not secretive, but not stupid)
149 umask 022
150
151 # debug-print() gets called from many places with verbose status information useful
152 # for tracking down problems. The output is in $T/eclass-debug.log.
153 # You can set ECLASS_DEBUG_OUTPUT to redirect the output somewhere else as well.
154 # The special "on" setting echoes the information, mixing it with the rest of the
155 # emerge output.
156 # You can override the setting by exporting a new one from the console, or you can
157 # set a new default in make.*. Here the default is "" or unset.
158
159 # in the future might use e* from /etc/init.d/functions.sh if i feel like it
160 debug-print() {
161         # if $T isn't defined, we're in dep calculation mode and
162         # shouldn't do anything
163         [[ $EBUILD_PHASE = depend || ! -d ${T} || ${#} -eq 0 ]] && return 0
164
165         if [[ ${ECLASS_DEBUG_OUTPUT} == on ]]; then
166                 printf 'debug: %s\n' "${@}" >&2
167         elif [[ -n ${ECLASS_DEBUG_OUTPUT} ]]; then
168                 printf 'debug: %s\n' "${@}" >> "${ECLASS_DEBUG_OUTPUT}"
169         fi
170
171         if [[ -w $T ]] ; then
172                 # default target
173                 printf '%s\n' "${@}" >> "${T}/eclass-debug.log"
174                 # let the portage user own/write to this file
175                 chgrp portage "${T}/eclass-debug.log" &>/dev/null
176                 chmod g+w "${T}/eclass-debug.log" &>/dev/null
177         fi
178 }
179
180 # The following 2 functions are debug-print() wrappers
181
182 debug-print-function() {
183         debug-print "${1}: entering function, parameters: ${*:2}"
184 }
185
186 debug-print-section() {
187         debug-print "now in section ${*}"
188 }
189
190 # Sources all eclasses in parameters
191 declare -ix ECLASS_DEPTH=0
192 inherit() {
193         ECLASS_DEPTH=$(($ECLASS_DEPTH + 1))
194         if [[ ${ECLASS_DEPTH} > 1 ]]; then
195                 debug-print "*** Multiple Inheritence (Level: ${ECLASS_DEPTH})"
196         fi
197
198         if [[ -n $ECLASS && -n ${!__export_funcs_var} ]] ; then
199                 echo "QA Notice: EXPORT_FUNCTIONS is called before inherit in" \
200                         "$ECLASS.eclass. For compatibility with <=portage-2.1.6.7," \
201                         "only call EXPORT_FUNCTIONS after inherit(s)." \
202                         | fmt -w 75 | while read -r ; do eqawarn "$REPLY" ; done
203         fi
204
205         local location
206         local olocation
207         local x
208
209         # These variables must be restored before returning.
210         local PECLASS=$ECLASS
211         local prev_export_funcs_var=$__export_funcs_var
212
213         local B_IUSE
214         local B_REQUIRED_USE
215         local B_DEPEND
216         local B_RDEPEND
217         local B_PDEPEND
218         while [ "$1" ]; do
219                 location="${ECLASSDIR}/${1}.eclass"
220                 olocation=""
221
222                 export ECLASS="$1"
223                 __export_funcs_var=__export_functions_$ECLASS_DEPTH
224                 unset $__export_funcs_var
225
226                 if [ "${EBUILD_PHASE}" != "depend" ] && \
227                         [ "${EBUILD_PHASE}" != "nofetch" ] && \
228                         [[ ${EBUILD_PHASE} != *rm ]] && \
229                         [[ ${EMERGE_FROM} != "binary" ]] ; then
230                         # This is disabled in the *rm phases because they frequently give
231                         # false alarms due to INHERITED in /var/db/pkg being outdated
232                         # in comparison the the eclasses from the portage tree. It's
233                         # disabled for nofetch, since that can be called by repoman and
234                         # that triggers bug #407449 due to repoman not exporting
235                         # non-essential variables such as INHERITED.
236                         if ! has $ECLASS $INHERITED $__INHERITED_QA_CACHE ; then
237                                 eqawarn "QA Notice: ECLASS '$ECLASS' inherited illegally in $CATEGORY/$PF $EBUILD_PHASE"
238                         fi
239                 fi
240
241                 # any future resolution code goes here
242                 if [ -n "$PORTDIR_OVERLAY" ]; then
243                         local overlay
244                         for overlay in ${PORTDIR_OVERLAY}; do
245                                 olocation="${overlay}/eclass/${1}.eclass"
246                                 if [ -e "$olocation" ]; then
247                                         location="${olocation}"
248                                         debug-print "  eclass exists: ${location}"
249                                 fi
250                         done
251                 fi
252                 debug-print "inherit: $1 -> $location"
253                 [ ! -e "$location" ] && die "${1}.eclass could not be found by inherit()"
254
255                 if [ "${location}" == "${olocation}" ] && \
256                         ! has "${location}" ${EBUILD_OVERLAY_ECLASSES} ; then
257                                 EBUILD_OVERLAY_ECLASSES="${EBUILD_OVERLAY_ECLASSES} ${location}"
258                 fi
259
260                 #We need to back up the value of DEPEND and RDEPEND to B_DEPEND and B_RDEPEND
261                 #(if set).. and then restore them after the inherit call.
262
263                 #turn off glob expansion
264                 set -f
265
266                 # Retain the old data and restore it later.
267                 unset B_IUSE B_REQUIRED_USE B_DEPEND B_RDEPEND B_PDEPEND
268                 [ "${IUSE+set}"       = set ] && B_IUSE="${IUSE}"
269                 [ "${REQUIRED_USE+set}" = set ] && B_REQUIRED_USE="${REQUIRED_USE}"
270                 [ "${DEPEND+set}"     = set ] && B_DEPEND="${DEPEND}"
271                 [ "${RDEPEND+set}"    = set ] && B_RDEPEND="${RDEPEND}"
272                 [ "${PDEPEND+set}"    = set ] && B_PDEPEND="${PDEPEND}"
273                 unset IUSE REQUIRED_USE DEPEND RDEPEND PDEPEND
274                 #turn on glob expansion
275                 set +f
276
277                 qa_source "$location" || die "died sourcing $location in inherit()"
278                 
279                 #turn off glob expansion
280                 set -f
281
282                 # If each var has a value, append it to the global variable E_* to
283                 # be applied after everything is finished. New incremental behavior.
284                 [ "${IUSE+set}"         = set ] && E_IUSE+="${E_IUSE:+ }${IUSE}"
285                 [ "${REQUIRED_USE+set}" = set ] && E_REQUIRED_USE+="${E_REQUIRED_USE:+ }${REQUIRED_USE}"
286                 [ "${DEPEND+set}"       = set ] && E_DEPEND+="${E_DEPEND:+ }${DEPEND}"
287                 [ "${RDEPEND+set}"      = set ] && E_RDEPEND+="${E_RDEPEND:+ }${RDEPEND}"
288                 [ "${PDEPEND+set}"      = set ] && E_PDEPEND+="${E_PDEPEND:+ }${PDEPEND}"
289
290                 [ "${B_IUSE+set}"     = set ] && IUSE="${B_IUSE}"
291                 [ "${B_IUSE+set}"     = set ] || unset IUSE
292                 
293                 [ "${B_REQUIRED_USE+set}"     = set ] && REQUIRED_USE="${B_REQUIRED_USE}"
294                 [ "${B_REQUIRED_USE+set}"     = set ] || unset REQUIRED_USE
295
296                 [ "${B_DEPEND+set}"   = set ] && DEPEND="${B_DEPEND}"
297                 [ "${B_DEPEND+set}"   = set ] || unset DEPEND
298
299                 [ "${B_RDEPEND+set}"  = set ] && RDEPEND="${B_RDEPEND}"
300                 [ "${B_RDEPEND+set}"  = set ] || unset RDEPEND
301
302                 [ "${B_PDEPEND+set}"  = set ] && PDEPEND="${B_PDEPEND}"
303                 [ "${B_PDEPEND+set}"  = set ] || unset PDEPEND
304
305                 #turn on glob expansion
306                 set +f
307
308                 if [[ -n ${!__export_funcs_var} ]] ; then
309                         for x in ${!__export_funcs_var} ; do
310                                 debug-print "EXPORT_FUNCTIONS: $x -> ${ECLASS}_$x"
311                                 declare -F "${ECLASS}_$x" >/dev/null || \
312                                         die "EXPORT_FUNCTIONS: ${ECLASS}_$x is not defined"
313                                 eval "$x() { ${ECLASS}_$x \"\$@\" ; }" > /dev/null
314                         done
315                 fi
316                 unset $__export_funcs_var
317
318                 has $1 $INHERITED || export INHERITED="$INHERITED $1"
319
320                 shift
321         done
322         ((--ECLASS_DEPTH)) # Returns 1 when ECLASS_DEPTH reaches 0.
323         if (( ECLASS_DEPTH > 0 )) ; then
324                 export ECLASS=$PECLASS
325                 __export_funcs_var=$prev_export_funcs_var
326         else
327                 unset ECLASS __export_funcs_var
328         fi
329         return 0
330 }
331
332 # Exports stub functions that call the eclass's functions, thereby making them default.
333 # For example, if ECLASS="base" and you call "EXPORT_FUNCTIONS src_unpack", the following
334 # code will be eval'd:
335 # src_unpack() { base_src_unpack; }
336 EXPORT_FUNCTIONS() {
337         if [ -z "$ECLASS" ]; then
338                 die "EXPORT_FUNCTIONS without a defined ECLASS"
339         fi
340         eval $__export_funcs_var+=\" $*\"
341 }
342
343 PORTAGE_BASHRCS_SOURCED=0
344
345 # @FUNCTION: source_all_bashrcs
346 # @DESCRIPTION:
347 # Source a relevant bashrc files and perform other miscellaneous
348 # environment initialization when appropriate.
349 #
350 # If EAPI is set then define functions provided by the current EAPI:
351 #
352 #  * default_* aliases for the current EAPI phase functions
353 #  * A "default" function which is an alias for the default phase
354 #    function for the current phase.
355 #
356 source_all_bashrcs() {
357         [[ $PORTAGE_BASHRCS_SOURCED = 1 ]] && return 0
358         PORTAGE_BASHRCS_SOURCED=1
359         local x
360
361         local OCC="${CC}" OCXX="${CXX}"
362
363         if [[ $EBUILD_PHASE != depend ]] ; then
364                 # source the existing profile.bashrcs.
365                 save_IFS
366                 IFS=$'\n'
367                 local path_array=($PROFILE_PATHS)
368                 restore_IFS
369                 for x in "${path_array[@]}" ; do
370                         [ -f "$x/profile.bashrc" ] && qa_source "$x/profile.bashrc"
371                 done
372         fi
373
374         if [ -r "${PORTAGE_BASHRC}" ] ; then
375                 if [ "$PORTAGE_DEBUG" != "1" ] || [ "${-/x/}" != "$-" ]; then
376                         source "${PORTAGE_BASHRC}"
377                 else
378                         set -x
379                         source "${PORTAGE_BASHRC}"
380                         set +x
381                 fi
382         fi
383
384         if [[ $EBUILD_PHASE != depend ]] ; then
385                 # The user's bashrc is the ONLY non-portage bit of code that can
386                 # change shopts without a QA violation.
387                 for x in "${PM_EBUILD_HOOK_DIR}"/${CATEGORY}/{${PN},${PN}:${SLOT},${P},${PF}}; do
388                         if [ -r "${x}" ]; then
389                                 # If $- contains x, then tracing has already been enabled
390                                 # elsewhere for some reason. We preserve it's state so as
391                                 # not to interfere.
392                                 if [ "$PORTAGE_DEBUG" != "1" ] || [ "${-/x/}" != "$-" ]; then
393                                         source "${x}"
394                                 else
395                                         set -x
396                                         source "${x}"
397                                         set +x
398                                 fi
399                         fi
400                 done
401         fi
402
403         [ ! -z "${OCC}" ] && export CC="${OCC}"
404         [ ! -z "${OCXX}" ] && export CXX="${OCXX}"
405 }
406
407 # === === === === === === === === === === === === === === === === === ===
408 # === === === === === functions end, main part begins === === === === ===
409 # === === === === === === === === === === === === === === === === === ===
410
411 export SANDBOX_ON="1"
412 export S=${WORKDIR}/${P}
413
414 # Turn of extended glob matching so that g++ doesn't get incorrectly matched.
415 shopt -u extglob
416
417 if [[ ${EBUILD_PHASE} == depend ]] ; then
418         QA_INTERCEPTORS="awk bash cc egrep equery fgrep g++
419                 gawk gcc grep javac java-config nawk perl
420                 pkg-config python python-config sed"
421 elif [[ ${EBUILD_PHASE} == clean* ]] ; then
422         unset QA_INTERCEPTORS
423 else
424         QA_INTERCEPTORS="autoconf automake aclocal libtoolize"
425 fi
426 # level the QA interceptors if we're in depend
427 if [[ -n ${QA_INTERCEPTORS} ]] ; then
428         for BIN in ${QA_INTERCEPTORS}; do
429                 BIN_PATH=$(type -Pf ${BIN})
430                 if [ "$?" != "0" ]; then
431                         BODY="echo \"*** missing command: ${BIN}\" >&2; return 127"
432                 else
433                         BODY="${BIN_PATH} \"\$@\"; return \$?"
434                 fi
435                 if [[ ${EBUILD_PHASE} == depend ]] ; then
436                         FUNC_SRC="${BIN}() {
437                                 if [ \$ECLASS_DEPTH -gt 0 ]; then
438                                         eqawarn \"QA Notice: '${BIN}' called in global scope: eclass \${ECLASS}\"
439                                 else
440                                         eqawarn \"QA Notice: '${BIN}' called in global scope: \${CATEGORY}/\${PF}\"
441                                 fi
442                         ${BODY}
443                         }"
444                 elif has ${BIN} autoconf automake aclocal libtoolize ; then
445                         FUNC_SRC="${BIN}() {
446                                 if ! has \${FUNCNAME[1]} eautoreconf eaclocal _elibtoolize \\
447                                         eautoheader eautoconf eautomake autotools_run_tool \\
448                                         autotools_check_macro autotools_get_subdirs \\
449                                         autotools_get_auxdir ; then
450                                         eqawarn \"QA Notice: '${BIN}' called by \${FUNCNAME[1]}: \${CATEGORY}/\${PF}\"
451                                         eqawarn \"Use autotools.eclass instead of calling '${BIN}' directly.\"
452                                 fi
453                         ${BODY}
454                         }"
455                 else
456                         FUNC_SRC="${BIN}() {
457                                 eqawarn \"QA Notice: '${BIN}' called by \${FUNCNAME[1]}: \${CATEGORY}/\${PF}\"
458                         ${BODY}
459                         }"
460                 fi
461                 eval "$FUNC_SRC" || echo "error creating QA interceptor ${BIN}" >&2
462         done
463         unset BIN_PATH BIN BODY FUNC_SRC
464 fi
465
466 # Subshell/helper die support (must export for the die helper).
467 export EBUILD_MASTER_PID=$BASHPID
468 trap 'exit 1' SIGTERM
469
470 if ! has "$EBUILD_PHASE" clean cleanrm depend && \
471         [ -f "${T}"/environment ] ; then
472         # The environment may have been extracted from environment.bz2 or
473         # may have come from another version of ebuild.sh or something.
474         # In any case, preprocess it to prevent any potential interference.
475         # NOTE: export ${FOO}=... requires quoting, unlike normal exports
476         preprocess_ebuild_env || \
477                 die "error processing environment"
478         # Colon separated SANDBOX_* variables need to be cumulative.
479         for x in SANDBOX_DENY SANDBOX_READ SANDBOX_PREDICT SANDBOX_WRITE ; do
480                 export PORTAGE_${x}="${!x}"
481         done
482         PORTAGE_SANDBOX_ON=${SANDBOX_ON}
483         export SANDBOX_ON=1
484         source "${T}"/environment || \
485                 die "error sourcing environment"
486         # We have to temporarily disable sandbox since the
487         # SANDBOX_{DENY,READ,PREDICT,WRITE} values we've just loaded
488         # may be unusable (triggering in spurious sandbox violations)
489         # until we've merged them with our current values.
490         export SANDBOX_ON=0
491         for x in SANDBOX_DENY SANDBOX_PREDICT SANDBOX_READ SANDBOX_WRITE ; do
492                 y="PORTAGE_${x}"
493                 if [ -z "${!x}" ] ; then
494                         export ${x}="${!y}"
495                 elif [ -n "${!y}" ] && [ "${!y}" != "${!x}" ] ; then
496                         # filter out dupes
497                         export ${x}="$(printf "${!y}:${!x}" | tr ":" "\0" | \
498                                 sort -z -u | tr "\0" ":")"
499                 fi
500                 export ${x}="${!x%:}"
501                 unset PORTAGE_${x}
502         done
503         unset x y
504         export SANDBOX_ON=${PORTAGE_SANDBOX_ON}
505         unset PORTAGE_SANDBOX_ON
506         [[ -n $EAPI ]] || EAPI=0
507 fi
508
509 if has "${EAPI:-0}" 4-python; then
510         shopt -s globstar
511 fi
512
513 if ! has "$EBUILD_PHASE" clean cleanrm ; then
514         if [[ $EBUILD_PHASE = depend || ! -f $T/environment || \
515                 -f $PORTAGE_BUILDDIR/.ebuild_changed ]] || \
516                 has noauto $FEATURES ; then
517                 # The bashrcs get an opportunity here to set aliases that will be expanded
518                 # during sourcing of ebuilds and eclasses.
519                 source_all_bashrcs
520
521                 # When EBUILD_PHASE != depend, INHERITED comes pre-initialized
522                 # from cache. In order to make INHERITED content independent of
523                 # EBUILD_PHASE during inherit() calls, we unset INHERITED after
524                 # we make a backup copy for QA checks.
525                 __INHERITED_QA_CACHE=$INHERITED
526
527                 # *DEPEND and IUSE will be set during the sourcing of the ebuild.
528                 # In order to ensure correct interaction between ebuilds and
529                 # eclasses, they need to be unset before this process of
530                 # interaction begins.
531                 unset EAPI DEPEND RDEPEND PDEPEND INHERITED IUSE REQUIRED_USE \
532                         ECLASS E_IUSE E_REQUIRED_USE E_DEPEND E_RDEPEND E_PDEPEND
533
534                 if [[ $PORTAGE_DEBUG != 1 || ${-/x/} != $- ]] ; then
535                         source "$EBUILD" || die "error sourcing ebuild"
536                 else
537                         set -x
538                         source "$EBUILD" || die "error sourcing ebuild"
539                         set +x
540                 fi
541
542                 if [[ "${EBUILD_PHASE}" != "depend" ]] ; then
543                         RESTRICT=${PORTAGE_RESTRICT}
544                         [[ -e $PORTAGE_BUILDDIR/.ebuild_changed ]] && \
545                         rm "$PORTAGE_BUILDDIR/.ebuild_changed"
546                 fi
547
548                 [ "${EAPI+set}" = set ] || EAPI=0
549
550                 # export EAPI for helpers (especially since we unset it above)
551                 export EAPI
552
553                 if has "$EAPI" 0 1 2 3 ; then
554                         export RDEPEND=${RDEPEND-${DEPEND}}
555                         debug-print "RDEPEND: not set... Setting to: ${DEPEND}"
556                 fi
557
558                 # add in dependency info from eclasses
559                 IUSE+="${IUSE:+ }${E_IUSE}"
560                 DEPEND+="${DEPEND:+ }${E_DEPEND}"
561                 RDEPEND+="${RDEPEND:+ }${E_RDEPEND}"
562                 PDEPEND+="${PDEPEND:+ }${E_PDEPEND}"
563                 REQUIRED_USE+="${REQUIRED_USE:+ }${E_REQUIRED_USE}"
564                 
565                 unset ECLASS E_IUSE E_REQUIRED_USE E_DEPEND E_RDEPEND E_PDEPEND \
566                         __INHERITED_QA_CACHE
567
568                 # alphabetically ordered by $EBUILD_PHASE value
569                 case "$EAPI" in
570                         0|1)
571                                 _valid_phases="src_compile pkg_config pkg_info src_install
572                                         pkg_nofetch pkg_postinst pkg_postrm pkg_preinst pkg_prerm
573                                         pkg_setup src_test src_unpack"
574                                 ;;
575                         2|3)
576                                 _valid_phases="src_compile pkg_config src_configure pkg_info
577                                         src_install pkg_nofetch pkg_postinst pkg_postrm pkg_preinst
578                                         src_prepare pkg_prerm pkg_setup src_test src_unpack"
579                                 ;;
580                         *)
581                                 _valid_phases="src_compile pkg_config src_configure pkg_info
582                                         src_install pkg_nofetch pkg_postinst pkg_postrm pkg_preinst
583                                         src_prepare pkg_prerm pkg_pretend pkg_setup src_test src_unpack"
584                                 ;;
585                 esac
586
587                 DEFINED_PHASES=
588                 for _f in $_valid_phases ; do
589                         if declare -F $_f >/dev/null ; then
590                                 _f=${_f#pkg_}
591                                 DEFINED_PHASES+=" ${_f#src_}"
592                         fi
593                 done
594                 [[ -n $DEFINED_PHASES ]] || DEFINED_PHASES=-
595
596                 unset _f _valid_phases
597
598                 if [[ $EBUILD_PHASE != depend ]] ; then
599
600                         if has distcc $FEATURES ; then
601                                 [[ -n $DISTCC_LOG ]] && addwrite "${DISTCC_LOG%/*}"
602                         fi
603
604                         if has ccache $FEATURES ; then
605
606                                 if [[ -n $CCACHE_DIR ]] ; then
607                                         addread "$CCACHE_DIR"
608                                         addwrite "$CCACHE_DIR"
609                                 fi
610
611                                 [[ -n $CCACHE_SIZE ]] && ccache -M $CCACHE_SIZE &> /dev/null
612                         fi
613
614                         if [[ -n $QA_PREBUILT ]] ; then
615
616                                 # these ones support fnmatch patterns
617                                 QA_EXECSTACK+=" $QA_PREBUILT"
618                                 QA_TEXTRELS+=" $QA_PREBUILT"
619                                 QA_WX_LOAD+=" $QA_PREBUILT"
620
621                                 # these ones support regular expressions, so translate
622                                 # fnmatch patterns to regular expressions
623                                 for x in QA_DT_NEEDED QA_FLAGS_IGNORED QA_PRESTRIPPED QA_SONAME ; do
624                                         if [[ $(declare -p $x 2>/dev/null) = declare\ -a* ]] ; then
625                                                 eval "$x=(\"\${$x[@]}\" ${QA_PREBUILT//\*/.*})"
626                                         else
627                                                 eval "$x+=\" ${QA_PREBUILT//\*/.*}\""
628                                         fi
629                                 done
630
631                                 unset x
632                         fi
633
634                         # This needs to be exported since prepstrip is a separate shell script.
635                         [[ -n $QA_PRESTRIPPED ]] && export QA_PRESTRIPPED
636                         eval "[[ -n \$QA_PRESTRIPPED_${ARCH/-/_} ]] && \
637                                 export QA_PRESTRIPPED_${ARCH/-/_}"
638                 fi
639         fi
640 fi
641
642 # unset USE_EXPAND variables that contain only the special "*" token
643 for x in ${USE_EXPAND} ; do
644         [ "${!x}" == "*" ] && unset ${x}
645 done
646 unset x
647
648 if has nostrip ${FEATURES} ${RESTRICT} || has strip ${RESTRICT}
649 then
650         export DEBUGBUILD=1
651 fi
652
653 if [[ $EBUILD_PHASE = depend ]] ; then
654         export SANDBOX_ON="0"
655         set -f
656
657         if [ -n "${dbkey}" ] ; then
658                 if [ ! -d "${dbkey%/*}" ]; then
659                         install -d -g ${PORTAGE_GID} -m2775 "${dbkey%/*}"
660                 fi
661                 # Make it group writable. 666&~002==664
662                 umask 002
663         fi
664
665         auxdbkeys="DEPEND RDEPEND SLOT SRC_URI RESTRICT HOMEPAGE LICENSE
666                 DESCRIPTION KEYWORDS INHERITED IUSE REQUIRED_USE PDEPEND PROVIDE EAPI
667                 PROPERTIES DEFINED_PHASES UNUSED_05 UNUSED_04
668                 UNUSED_03 UNUSED_02 UNUSED_01"
669
670         # The extra $(echo) commands remove newlines.
671         if [ -n "${dbkey}" ] ; then
672                 > "${dbkey}"
673                 for f in ${auxdbkeys} ; do
674                         echo $(echo ${!f}) >> "${dbkey}" || exit $?
675                 done
676         else
677                 for f in ${auxdbkeys} ; do
678                         echo $(echo ${!f}) 1>&9 || exit $?
679                 done
680                 exec 9>&-
681         fi
682         set +f
683 else
684         # Note: readonly variables interfere with preprocess_ebuild_env(), so
685         # declare them only after it has already run.
686         declare -r $PORTAGE_READONLY_METADATA $PORTAGE_READONLY_VARS
687         case "$EAPI" in
688                 0|1|2)
689                         [[ " ${FEATURES} " == *" force-prefix "* ]] && \
690                                 declare -r ED EPREFIX EROOT
691                         ;;
692                 *)
693                         declare -r ED EPREFIX EROOT
694                         ;;
695         esac
696
697         if [[ -n $EBUILD_SH_ARGS ]] ; then
698                 (
699                         # Don't allow subprocesses to inherit the pipe which
700                         # emerge uses to monitor ebuild.sh.
701                         exec 9>&-
702                         ebuild_main ${EBUILD_SH_ARGS}
703                         exit 0
704                 )
705                 exit $?
706         fi
707 fi
708
709 # Do not exit when ebuild.sh is sourced by other scripts.
710 true